// Traitement du temps avec le type DATE Oracle

package ExemplesJDBC;
import java.sql.*;
import java.util.*;

public class ExempleTraitementDuTemps 
{
  public static void main (String args [])
       throws SQLException, ClassNotFoundException, java.io.IOException
  {
    // Charger le pilote JDBC d'Oracle
    Class.forName ("oracle.jdbc.driver.OracleDriver");

    // Connexion  une BD
    Connection uneConnection =
      DriverManager.getConnection ("jdbc:oracle:thin:@localhost:1521:orcl", "godin", "oracle");

/*      PreparedStatement unEnoncSQL = uneConnection.prepareStatement
        ("DROP TABLE LeTemps");
      int n = unEnoncSQL.executeUpdate();  
*/
       PreparedStatement unEnoncSQL = uneConnection.prepareStatement
      ("CREATE TABLE LeTemps(id NUMBER, laDate DATE, lHeure DATE, laDateEtHeure DATE)");
       int n = unEnoncSQL.executeUpdate();  

       unEnoncSQL = uneConnection.prepareStatement
        ("INSERT INTO LeTemps(id,laDate,lHeure,laDateEtHeure) VALUES(?,?,?,?)");
        unEnoncSQL.setInt(1,1);
        Calendar maintenant = Calendar.getInstance(); // cre un calendrier grgorien avec date actuelle


        // Traitement de la date (sans l'heure)
        // Calendar.getTime() retourne un java.util.Date
        // java.util.Date.getTime() retourne le temps en long
        java.sql.Date laDate = new java.sql.Date(maintenant.getTime().getTime());
        unEnoncSQL.setDate(2,laDate);

        // Traitement de l'heure (sans la date)
        java.sql.Time leTime = new java.sql.Time(maintenant.getTime().getTime());
        unEnoncSQL.setTime(3,leTime);

        // Date + heure
        java.sql.Timestamp leTimestamp = new java.sql.Timestamp(maintenant.getTime().getTime());
        unEnoncSQL.setTimestamp(4,leTimestamp);

        n = unEnoncSQL.executeUpdate();

    unEnoncSQL = uneConnection.prepareStatement
        ("SELECT id,laDate,lHeure,laDateEtHeure FROM LeTemps" );
    ResultSet rsultatSelect = unEnoncSQL.executeQuery();
    while (rsultatSelect.next ()){
        int leId = rsultatSelect.getInt("id");
        laDate = rsultatSelect.getDate("laDate");
        leTime = rsultatSelect.getTime("lHeure");
        leTimestamp = rsultatSelect.getTimestamp("laDateEtHeure");
        
        System.out.println ("id:" + leId);
        System.out.println ("la date :" + laDate);
        System.out.println ("l'heure :" + leTime);
        System.out.println ("la date avec l'heure :" + leTimestamp);
    }
    // Fermeture de l'nonc et de la connexion
    unEnoncSQL.close();
    uneConnection.close();
  }
}