// Exemples de positionnements dans un ResultSet JDBC 2

package ExemplesJDBC;
import java.sql.*;

class ResultSetScrollable
{
    public static void main (String args [])
    throws SQLException, ClassNotFoundException, java.io.IOException
    {
        // Charger le pilote JDBC d'Oracle
        Class.forName ("oracle.jdbc.driver.OracleDriver");

        // Connexion  une BD
        Connection uneConnection =
        DriverManager.getConnection ("jdbc:oracle:thin:@localhost:1521:orcl", "godin", "oracle");

        // Cration d'un nonc avec ResultSet dfilable (srollable)
        Statement unEnoncSQL =
        uneConnection.createStatement(
            ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);

        // Excution d'un SELECT
        ResultSet rsultatSelect = unEnoncSQL.executeQuery
        ("SELECT noClient, nomClient FROM CLIENT");

        // Affichage des lignes du ResultSet
        int noClient;
        String nomClient;
        System.out.println("Liste des clients");
        System.out.println("Position\tNoClient\tNomClient");
        int position = 1;
        while (rsultatSelect.next ()){
            noClient = rsultatSelect.getInt ("noClient");
            nomClient = rsultatSelect.getString ("nomClient");
            System.out.println(position+"\t"+noClient+"\t"+nomClient);
            position++;
        }
        
        // Exemples de positionnement de curseur (scrollable)
        //Positionnement  la premire ligne du ResultSet
        rsultatSelect.first();
        System.out.println("Premier client :");
        noClient = rsultatSelect.getInt ("noClient");
        nomClient = rsultatSelect.getString ("nomClient");
        System.out.println(noClient+"\t"+nomClient);
        
        // Positionnement  la dernire ligne du ResultSet
        rsultatSelect.last();
        System.out.println("Dernier client :");
        noClient = rsultatSelect.getInt ("noClient");
        nomClient = rsultatSelect.getString ("nomClient");
        System.out.println(noClient+"\t"+nomClient);

        // Positionnement  la troisime ligne
        rsultatSelect.absolute(3);
        System.out.println("3ieme client :");
        noClient = rsultatSelect.getInt ("noClient");
        nomClient = rsultatSelect.getString ("nomClient");
        System.out.println(noClient+"\t"+nomClient);
        
        // Positionnement relatif (avancer de 2 lignes)
        rsultatSelect.relative(2);
        System.out.println("Avancer de deux :");
        noClient = rsultatSelect.getInt ("noClient");
        nomClient = rsultatSelect.getString ("nomClient");
        System.out.println(noClient+"\t"+nomClient);

        // Positionnement  la ligne prcdente
        rsultatSelect.previous();
        System.out.println("Client prcdent :");
        noClient = rsultatSelect.getInt ("noClient");
        nomClient = rsultatSelect.getString ("nomClient");
        System.out.println(noClient+"\t"+nomClient);

        // Fermeture de l'nonc et de la connexion
        unEnoncSQL.close();
        uneConnection.close();
    }
}